#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define SE stderr
#define PI 3.141592654

typedef struct { double x,y; } bod_2d;
typedef struct { bod_2d *op,*tp; int N; } poly;

poly P, DispP;
int i,j;
FILE *F;

void WritePSHeader(void){

  fprintf(F,"%%!PS (c) MisoF\n\n");
  
  fprintf(F,"%% ---------\n%% definicie\n%% ---------\n\n");
  fprintf(F,"/cm {72 2.54 div mul} def\n/pis {newpath moveto show} def\n\n");

  fprintf(F,"%% --------\n%% hlavicka\n%% --------\n\n");
  fprintf(F,"/Times-Roman findfont 24 scalefont setfont\n");
  fprintf(F,"(2D grafika - homework #1) 174 800 pis\n\n");

  fprintf(F,"/Times-Roman findfont 16 scalefont setfont\n1.4 setlinewidth\n\n");
  fprintf(F,"(\\(c\\) MisoF) 520 10 pis\n\n");


  fprintf(F,"0.8 0.0 0.0 setrgbcolor\n");
  fprintf(F,"newpath 50 750 moveto 50 770 lineto 70 770 lineto");
  fprintf(F," closepath fill\n");
  fprintf(F,"0.0 0.0 0.0 setrgbcolor\n");
  fprintf(F,"newpath 50 750 moveto 50 770 lineto 70 770 lineto");
  fprintf(F," closepath stroke\n");
  fprintf(F,"0 setgray (Original shape) 80 755 pis\n\n");

  fprintf(F,"0.0 0.8 0.0 setrgbcolor\n");
  fprintf(F,"newpath 70 725 moveto 50 745 lineto 70 745 lineto");
  fprintf(F," closepath fill\n");
  fprintf(F,"0.0 0.0 0.0 setrgbcolor\n");
  fprintf(F,"newpath 70 725 moveto 50 745 lineto 70 745 lineto");
  fprintf(F," closepath stroke\n");
  fprintf(F,"0 setgray (Transformed shape) 80 730 pis\n\n");

  fprintf(F,"%% -------------------\n%% popis transformacie\n");
  fprintf(F,"%% -------------------\n\n");
  fprintf(F,"(Transformation:) 300 755 pis\n");
}

void ScaleCoordinatesForDisplay(void){
  double minx,maxx,miny,maxy;
  int i;
  
  minx=maxx=P.op[0].x;
  miny=maxy=P.op[0].y;
  for (i=1;i<P.N;i++){
    if (P.op[i].x<minx) minx=P.op[i].x; if (P.op[i].x>maxx) maxx=P.op[i].x;
    if (P.op[i].y<miny) miny=P.op[i].y; if (P.op[i].y>maxy) maxy=P.op[i].y;
  }
  for (i=0;i<P.N;i++){
    if (P.tp[i].x<minx) minx=P.tp[i].x; if (P.tp[i].x>maxx) maxx=P.tp[i].x;
    if (P.tp[i].y<miny) miny=P.tp[i].y; if (P.tp[i].y>maxy) maxy=P.tp[i].y;
  }

  if (minx==maxx) { for (i=0;i<P.N;i++) DispP.op[i].x=250; } 
   else{for(i=0;i<P.N;i++)DispP.op[i].x=(P.op[i].x-minx)*(450/(maxx-minx))+50;}
  if (miny==maxy) { for (i=0;i<P.N;i++) DispP.op[i].y=250; } 
   else{for(i=0;i<P.N;i++)DispP.op[i].y=(P.op[i].y-miny)*(450/(maxy-miny))+50;}
   
  if (minx==maxx) { for (i=0;i<P.N;i++) DispP.tp[i].x=250; } 
   else{for(i=0;i<P.N;i++)DispP.tp[i].x=(P.tp[i].x-minx)*(450/(maxx-minx))+50;}
  if (miny==maxy) { for (i=0;i<P.N;i++) DispP.tp[i].y=250; } 
   else{for(i=0;i<P.N;i++)DispP.tp[i].y=(P.tp[i].y-miny)*(450/(maxy-miny))+50;}
}

void WritePS(void){
  int i;
  
  fprintf(F,"\n%% ---------------\n%% povodny polygon\n%% ---------------\n\n");
  fprintf(F,"/poly1 {\n  newpath\n");
  fprintf(F,"  %.5f %.5f moveto\n",DispP.op[0].x,DispP.op[0].y);
  for (i=1;i<P.N;i++) fprintf(F,"  %.5f %.5f lineto\n",DispP.op[i].x,DispP.op[i].y);
  fprintf(F,"  closepath\n} def\n\n");

  fprintf(F,"0.8 0.0 0.0 setrgbcolor\npoly1 fill\n");
  fprintf(F,"0.0 0.0 0.0 setrgbcolor\npoly1 stroke\n\n");

  fprintf(F,"0 setgray\n");
  for (i=0;i<P.N;i++) 
    fprintf(F,"([%.1f,%.1f]) %.5f %.5f pis\n",P.op[i].x,P.op[i].y,DispP.op[i].x+5,DispP.op[i].y+5);

  fprintf(F,"\n%% ------------\n%% novy polygon\n%% ------------\n\n");
  fprintf(F,"/poly2 {\n  newpath\n");
  fprintf(F,"  %.5f %.5f moveto\n",DispP.tp[0].x,DispP.tp[0].y);
  for (i=1;i<P.N;i++) fprintf(F,"  %.5f %.5f lineto\n",DispP.tp[i].x,DispP.tp[i].y);
  fprintf(F,"  closepath\n} def\n\n");

  fprintf(F,"0.0 0.8 0.0 setrgbcolor\npoly2 fill\n");
  fprintf(F,"0.0 0.0 0.0 setrgbcolor\npoly2 stroke\n\n");

  fprintf(F,"0 setgray\n");
  for (i=0;i<P.N;i++) 
    fprintf(F,"([%.1f,%.1f]) %.5f %.5f pis\n",P.tp[i].x,P.tp[i].y,DispP.tp[i].x+5,DispP.tp[i].y+5);

  fprintf(F,"\nshowpage\n");
}

void Transform(poly *P){
  /*
  Transformacie nacitava zo vstupu
  a sklada ich priamo v ramci procedury
  -- je to z programatorskeho hladiska 
     cistejsie [a hlavne sa potom tie
     transformacie skladaju v tejto 
     procedure a nie predtym, ako sa zavola]
  */
  double M[3][3],M1[3][3],M2[3][3];
  double xx,yy,zz;
  char T;
  int ptrans,i,j,k;
  
  /* inicializuje maticu transformacie na identicku */
  for (i=0;i<9;i++) M[i/3][i%3]=((i/3)==(i%3));
  
  scanf("%c ",&T); if (T>96) T-=32; ptrans=0;
  while (T!='E') {
    /* kym mame transformaciu */
    ptrans++;

    /* TRANSLACIA */
    if (T=='T') {
      scanf("%lf %lf ",&xx,&yy);
      fprintf(F,"(Translation [%.1f,%.1f]) %d %d pis\n",xx,yy,300,755-17*ptrans);
      M1[0][0]=1; M1[0][1]=0; M1[0][2]=0;
      M1[1][0]=0; M1[1][1]=1; M1[1][2]=0;
      M1[2][0]=xx; M1[2][1]=yy; M1[2][2]=1;
      /* zlozime s predchadzajucou */
      for (i=0;i<3;i++) for (j=0;j<3;j++) { M2[i][j]=0;
        for (k=0;k<3;k++) M2[i][j]+=M[i][k]*M1[k][j]; }
      for (i=0;i<9;i++) M[i/3][i%3]=M2[i/3][i%3];
    }
    /* END TRANSLACIA */
    
    /* ROTACIA */
    if (T=='R') {
      scanf("%lf %lf %lf ",&xx,&yy,&zz);
      fprintf(F,"(Rotation center=[%.1f,%.1f] angle=%.1f) %d %d pis\n",xx,yy,zz,300,755-17*ptrans);
      M1[0][0]=1; M1[0][1]=0; M1[0][2]=0;
      M1[1][0]=0; M1[1][1]=1; M1[1][2]=0;
      M1[2][0]=-xx; M1[2][1]=-yy; M1[2][2]=1;
      /* posunieme stred otacania do [0,0] */
      for (i=0;i<3;i++) for (j=0;j<3;j++) { M2[i][j]=0;
        for (k=0;k<3;k++) M2[i][j]+=M[i][k]*M1[k][j]; }
      for (i=0;i<9;i++) M[i/3][i%3]=M2[i/3][i%3];
      
      zz=(zz/180)*PI;
      M1[0][0]=cos(zz); M1[0][1]=sin(zz); M1[0][2]=0;
      M1[1][0]=-sin(zz); M1[1][1]=cos(zz); M1[1][2]=0;
      M1[2][0]=0; M1[2][1]=0; M1[2][2]=1;
      /* otocime */
      for (i=0;i<3;i++) for (j=0;j<3;j++) { M2[i][j]=0;
        for (k=0;k<3;k++) M2[i][j]+=M[i][k]*M1[k][j]; }
      for (i=0;i<9;i++) M[i/3][i%3]=M2[i/3][i%3];
      
      M1[0][0]=1; M1[0][1]=0; M1[0][2]=0;
      M1[1][0]=0; M1[1][1]=1; M1[1][2]=0;
      M1[2][0]=xx; M1[2][1]=yy; M1[2][2]=1;
      /* posunieme spaet */
      for (i=0;i<3;i++) for (j=0;j<3;j++) { M2[i][j]=0;
        for (k=0;k<3;k++) M2[i][j]+=M[i][k]*M1[k][j]; }
      for (i=0;i<9;i++) M[i/3][i%3]=M2[i/3][i%3];
    }
    /* END ROTACIA */
    
    /* SKALOVANIE */
    if (T=='S') {
      scanf("%lf %lf ",&xx,&yy);
      fprintf(F,"(Scaling x %.2f times, y %.2f times) %d %d pis\n",xx,yy,300,755-17*ptrans);
      M1[0][0]=xx; M1[0][1]=0; M1[0][2]=0;
      M1[1][0]=0; M1[1][1]=yy; M1[1][2]=0;
      M1[2][0]=0; M1[2][1]=0; M1[2][2]=1;
      /* zlozime s predchadzajucou */
      for (i=0;i<3;i++) for (j=0;j<3;j++) { M2[i][j]=0;
        for (k=0;k<3;k++) M2[i][j]+=M[i][k]*M1[k][j]; }
      for (i=0;i<9;i++) M[i/3][i%3]=M2[i/3][i%3];
    }
    /* END SKALOVANIE */

    /* a nacitame dalsiu transformaciu */
    scanf("%c ",&T); if (T>96) T-=32;
  }

  /* transformuje body */

  for (i=0;i<(*P).N;i++) {
    xx=(*P).op[i].x*M[0][0] + (*P).op[i].y*M[1][0] + M[2][0];
    yy=(*P).op[i].x*M[0][1] + (*P).op[i].y*M[1][1] + M[2][1];
    zz=(*P).op[i].x*M[0][2] + (*P).op[i].y*M[1][2] + M[2][2];
    if (zz==0) {
      fprintf(SE,"!!!Something rotten, this shouldn't happen!!!\n");
      exit(1); 
    }
    (*P).tp[i].x=xx/zz; (*P).tp[i].y=yy/zz;
  }

}

int main(int argc, char **argv){
  fprintf(SE,"2D Grafika - Domaca uloha #1 v1.0\n(c) Miso Forisek\n");
  if (argc>1){
    if (strcmp(argv[1],"--help")==0) {
      fprintf(SE,"\nProgram nepodporuje ziadne parametre okrem --help.\n");
      fprintf(SE,"\nSyntax vstupu:\n");
      fprintf(SE,"N - pocet vrcholov polygonu\n");
      fprintf(SE,"x_1 y_1...x_N y_N - suradnice vrcholov polygonu po obvode\n");
      fprintf(SE,"                      odporucane su medzi 0.0 a 500.0\n");
      fprintf(SE,"nasleduje niekolko transformacii, zadavanych v tvare:\n");
      fprintf(SE,"T dx dy - translate, t.j. posunutie o vektor [dx,dy]\n");
      fprintf(SE,"R cx cy alfa - rotate, t.j. rotacia okolo [cx,cy] o alfa\n");
      fprintf(SE,"               stupnov proti smeru hod. ruciciek\n");
      fprintf(SE,"S mx my - scale, t.j. skalovanie dx-krat v smere osi x\n");
      fprintf(SE,"          a dy-krat v smere osi y\n");
      fprintf(SE,"E - end, t.j. koniec\n\n");
      fprintf(SE,"Program zostroji vyslednu transformaciu, zobrazi nou");
      fprintf(SE," polygon\n a vypise transformovane suradnice vrcholov\n");
      fprintf(SE,"v poradi, v akom boli zadane na vstupe.\n");
      fprintf(SE,"Okrem toho vytvori subor hw1.ps s grafickym vystupom.\n");
      return 0;
    } else {
      fprintf(SE,"Neznamy parameter. Pouzi --help\n");
      return 0;
    }
  }

  /* nacita polygon */

  scanf("%d ",&P.N);
  P.op=malloc(P.N*sizeof(bod_2d));
  P.tp=malloc(P.N*sizeof(bod_2d));
  DispP.op=malloc(P.N*sizeof(bod_2d));
  DispP.tp=malloc(P.N*sizeof(bod_2d));
  for (i=0;i<P.N;i++) scanf("%lf %lf ",&P.op[i].x,&P.op[i].y);
  F=fopen("hw1.ps","wt");
  WritePSHeader();

  /* nacita a spravi transformacie */

  Transform(&P);

  /* vypise vysledok */
  
  for (i=0;i<P.N;i++) printf("%.6f %.6f\n",P.tp[i].x,P.tp[i].y);
  ScaleCoordinatesForDisplay();
  WritePS();
  
  free(P.op);
  free(P.tp);
  free(DispP.op);
  free(DispP.tp);
  fclose(F);
  return 0;
}
